<template lang="pug">
  .tabs
    ul.tabs__btns
      li.tabs__btn(:class="{active : activeTab == 'companies'}" @click="changeTab('companies')"): span Компаниям
      li.tabs__btn(:class="{active : activeTab == 'private'}" @click="changeTab('private')"): span Частным клиентам
      li.tabs__btn.tabs__btn--red-circle(:class="{active : activeTab == 'individual'}" @click="changeTab('individual')"): span Спец. предложения
      span.tabs__btn-bg(:style="{top: topTranslateBg + 'px', left: leftTranslateBg +'px', width: widthElem}")
    .tabs__content
        ul
          transition-group(name="fade").tabs__elems
            li(v-for="item in sortServices" :key="'item' + item.id").tabs__elem
              i.tabs__icon: img(:src="require(`@/assets/img/${item.imgSrc}`)" :alt="item.alt")
              h4.tabs__title.title-4 {{item.title}}
              p.tabs__text {{item.text}}
</template>

<script>
import axios from "axios";

export default {
  name: "vTabs",
  data() {
    return {
      services: [],
      endpoint: "http://localhost:3000/services",
      activeTab: "companies",
      leftTranslateBg: 0,
      topTranslateBg: 0,
      widthElem: "162px",
      windowWidth: 0,
    };
  },
  computed: {
    sortServices() {
      return this.services.filter((item) => item.category == this.activeTab);
    },
  },
  methods: {
    async getServices() {
      try {
        const { data } = await axios.get(this.endpoint);
        this.services = await data;
        console.log(this.services);
      } catch (e) {
        console.log(e);
      }
    },
    changeTab(tab) {
      if (tab == "companies") {
        this.activeTab = "companies";
        if (this.windowWidth > 738) {
          this.leftTranslateBg = 0;
          this.widthElem = 162 + "px";
          this.topTranslateBg = 0;
        } else {
          this.topTranslateBg = 0;
          this.widthElem = 100 + "%";
        }
      } else if (tab == "private") {
        this.activeTab = "private";
        if (this.windowWidth > 738) {
          this.leftTranslateBg = 162;
          this.widthElem = 217 + "px";
          this.topTranslateBg = 0;
        } else {
          this.topTranslateBg = 40;
          this.widthElem = 100 + "%";
        }
      } else {
        this.activeTab = "individual";
        if (this.windowWidth > 738) {
          this.leftTranslateBg = 379;
          this.widthElem = 224 + "px";
          this.topTranslateBg = 0;
        } else {
          this.topTranslateBg = 80;
          this.widthElem = 100 + "%";
        }
      }
    },
  },
  created() {
    this.getServices();
    this.windowWidth = window.innerWidth;
    if (this.windowWidth < 738) {
      this.widthElem = 100 + "%";
    }
  },
  mounted() {
    window.onresize = () => {
      this.windowWidth = window.innerWidth;
    };
  },
};
</script>

<style lang="scss">
.tabs {
  height: 967px;
  width: 812px;

  padding: 48px 48px 64px;
  box-sizing: border-box;
  box-shadow: 0px 12px 40px 2px rgba(0, 0, 0, 0.05);
  border-radius: 4px;

  background-color: $white;
  &__btns {
    position: relative;
    display: flex;
    justify-content: space-between;

    max-width: 602px;
    height: 40px;

    border-radius: 20px;
    border: 1px solid #d3dce4;
    list-style: none;
    @media (max-width: 740px) {
      flex-direction: column;
      align-items: center;
      max-width: 100%;
      height: 120px;
    }
  }
  &__btn {
    padding: 7px 36px;
    box-sizing: border-box;

    line-height: 26px;
    span {
      position: relative;
      z-index: 100;

      cursor: pointer;
      transition: all 0.3s;
      &:hover {
        color: $blue;
      }
    }
    &.active span {
      color: $white;
      &:hover {
        color: $white;
      }
    }
    &--red-circle {
      position: relative;
      &::before {
        content: "";
        position: absolute;
        z-index: 101;
        top: 7px;
        right: 24px;

        width: 6px;
        height: 6px;

        border-radius: 3px;

        background-color: $orange-circle;
      }
    }
  }
  &__btn-bg {
    position: absolute;
    top: 0;

    height: 40px;

    border-radius: 20px;

    background-color: $blue;
    transition: all 0.25s ease-in-out;
  }
  &__elems {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-column-gap: 30px;
    grid-row-gap: 64px;

    margin-top: 40px;

    list-style: none;
  }
  &__elem {
    max-width: 300px;
    &:hover {
      .tabs__icon img {
        animation: little-shake 0.8s cubic-bezier(0.36, 0.07, 0.19, 0.97) both;
      }
    }
  }
  &__icon {
    display: block;

    margin-bottom: 16px;
  }
  &__title {
    margin: 0 0 10px 0;

    color: $black;
  }
  &__text {
    margin: 0;

    font: 400 14px/20px "Museo Sans", sans-serif;
    color: $gray;
  }
}
</style>
